"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterStoreService = void 0;
const client_ssm_1 = require("@aws-sdk/client-ssm");
const common_1 = require("@nestjs/common");
const constants_1 = require("../../../src/constants");
let ParameterStoreService = class ParameterStoreService {
    constructor(client) {
        this.client = client;
    }
    async getParametersByPath(path, decrypt = false, recursive = false) {
        let allParameters = [];
        let nextParametersToken;
        do {
            const getParameters = new client_ssm_1.GetParametersByPathCommand({
                NextToken: nextParametersToken,
                Path: path,
                Recursive: recursive,
                WithDecryption: decrypt,
            });
            const { NextToken, Parameters = [] } = await this.client.send(getParameters);
            allParameters = allParameters.concat(Parameters);
            nextParametersToken = NextToken;
        } while (Boolean(nextParametersToken));
        return allParameters;
    }
};
exports.ParameterStoreService = ParameterStoreService;
exports.ParameterStoreService = ParameterStoreService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.PARAMETER_STORE_SSM_CLIENT)),
    __metadata("design:paramtypes", [client_ssm_1.SSMClient])
], ParameterStoreService);
//# sourceMappingURL=parameter-store.service.js.map