"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ParameterStoreConfigModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterStoreConfigModule = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("../../src/constants");
const parameter_store_service_1 = require("../../src/modules/aws/parameter-store/parameter-store.service");
const config_service_1 = require("../../src/modules/config/config.service");
const config_parameters_provider_1 = require("../../src/shared/provider/config/config-parameters.provider");
const properties_provider_1 = require("../../src/shared/provider/config/properties.provider");
const ssm_client_provider_1 = require("../../src/shared/provider/config/ssm-client.provider");
let ParameterStoreConfigModule = ParameterStoreConfigModule_1 = class ParameterStoreConfigModule {
    static register(options) {
        const propertiesProvider = (0, properties_provider_1.default)(options);
        return {
            exports: [config_service_1.ParameterStoreConfigService, constants_1.PARAMETER_STORE_CONFIG_PARAMETERS],
            module: ParameterStoreConfigModule_1,
            providers: [propertiesProvider, config_parameters_provider_1.default, ssm_client_provider_1.default, config_service_1.ParameterStoreConfigService, parameter_store_service_1.ParameterStoreService],
        };
    }
    static registerAsync(options) {
        const providers = this.createAsyncProviders(options);
        return {
            exports: [config_service_1.ParameterStoreConfigService, constants_1.PARAMETER_STORE_CONFIG_PARAMETERS],
            imports: options.imports || [],
            module: ParameterStoreConfigModule_1,
            providers,
        };
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                inject: options.inject || [],
                provide: constants_1.PARAMETER_STORE_CONFIG_PROPERTIES,
                useFactory: options.useFactory,
            };
        }
        const inject = options.useExisting || options.useClass;
        return {
            inject: inject ? [inject] : [],
            provide: constants_1.PARAMETER_STORE_CONFIG_PROPERTIES,
            useFactory: async (optionsFactory) => {
                return optionsFactory.createOptions();
            },
        };
    }
    static createAsyncProviders(properties) {
        const optionsProvider = this.createAsyncOptionsProvider(properties);
        const requestProviders = [optionsProvider, config_parameters_provider_1.default, ssm_client_provider_1.default, config_service_1.ParameterStoreConfigService, parameter_store_service_1.ParameterStoreService];
        if (properties.useExisting || properties.useFactory || !properties.useClass) {
            return requestProviders;
        }
        return [
            ...requestProviders,
            {
                provide: properties.useClass,
                useClass: properties.useClass,
            },
        ];
    }
};
exports.ParameterStoreConfigModule = ParameterStoreConfigModule;
exports.ParameterStoreConfigModule = ParameterStoreConfigModule = ParameterStoreConfigModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], ParameterStoreConfigModule);
//# sourceMappingURL=config.module.js.map