"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var ParameterStoreConfigService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParameterStoreConfigService = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("../../src/constants");
let ParameterStoreConfigService = ParameterStoreConfigService_1 = class ParameterStoreConfigService {
    constructor(parameters) {
        this.parameters = parameters;
    }
    get(name, defaultValue = null) {
        const found = this.parameters.find((parameter) => parameter.Name?.endsWith(name));
        if (!found) {
            return defaultValue;
        }
        return found.Value;
    }
    getBool(name, defaultValue = null) {
        const found = this.parameters.find((parameter) => parameter.Name?.endsWith(name));
        if (!found) {
            return defaultValue;
        }
        const isTrue = ParameterStoreConfigService_1.trutyValues.includes(found.Value ?? "");
        return isTrue;
    }
    getNumber(name, defaultValue = null) {
        const found = this.parameters.find((parameter) => parameter.Name?.endsWith(name));
        if (!found?.Value) {
            return defaultValue;
        }
        return +found.Value;
    }
};
exports.ParameterStoreConfigService = ParameterStoreConfigService;
ParameterStoreConfigService.trutyValues = ["true", "True", "1", "y", "yes", "Yes"];
exports.ParameterStoreConfigService = ParameterStoreConfigService = ParameterStoreConfigService_1 = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.PARAMETER_STORE_CONFIG_PARAMETERS)),
    __metadata("design:paramtypes", [Array])
], ParameterStoreConfigService);
//# sourceMappingURL=config.service.js.map