"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../../../constants");
const parameter_store_service_1 = require("../../../src/modules/aws/parameter-store/parameter-store.service");
const ParameterStoreConfigParametersProvider = {
    inject: [constants_1.PARAMETER_STORE_CONFIG_PROPERTIES, parameter_store_service_1.ParameterStoreService],
    provide: constants_1.PARAMETER_STORE_CONFIG_PARAMETERS,
    useFactory: (configOptions, parameterStoreService) => {
        return parameterStoreService.getParametersByPath(configOptions.ssmParamStorePath, configOptions.ssmDecryptParams ?? false, configOptions.ssmRecursive ?? false);
    },
};
exports.default = ParameterStoreConfigParametersProvider;
//# sourceMappingURL=config-parameters.provider.js.map